1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198
|
#!/usr/bin/env bash
###########################################################################
# prepare_commit.sh
# ---------------------
# Date : August 2008
# Copyright : (C) 2008 by Juergen E. Fischer
# Email : jef at norbit dot de
###########################################################################
# #
# This program is free software; you can redistribute it and/or modify #
# it under the terms of the GNU General Public License as published by #
# the Free Software Foundation; either version 2 of the License, or #
# (at your option) any later version. #
# #
###########################################################################
TOPLEVEL=$(git rev-parse --show-toplevel)
PATH=$TOPLEVEL/scripts:$PATH:$PWD/scripts
if ! tty -s && [[ "$0" =~ /pre-commit ]]; then
exec </dev/tty
fi
cd "$TOPLEVEL"
# GNU prefix command for bsd/mac os support (gsed, gsplit)
GP=
if [[ "$OSTYPE" == *bsd* ]] || [[ "$OSTYPE" =~ darwin* ]]; then
GP=g
fi
if ! type -p astyle.sh >/dev/null; then
echo astyle.sh not found
exit 1
fi
if ! type -p colordiff >/dev/null; then
colordiff()
{
cat "$@"
}
fi
if [ "$1" = "-c" ]; then
echo "Cleaning..."
remove_temporary_files.sh
fi
set -e
# determine changed files
MODIFIED=$(git status --porcelain| ${GP}sed -ne "s/^ *[MA] *//p" | sort -u)
if [ -z "$MODIFIED" ]; then
echo nothing was modified
exit 0
fi
HAS_AG=false
if command -v ag > /dev/null; then
HAS_AG=true
fi
HAS_UNBUFFER=false
if command -v unbuffer > /dev/null; then
HAS_UNBUFFER=true
fi
# Run spell checker if requirements are met
if test "$HAS_AG" != "true"; then
echo "WARNING: the ag(1) executable was not found, spell checker could not run" >&2
elif test "$HAS_UNBUFFER" != "true"; then
echo "WARNING: the unbuffer(1) executable was not found, spell checker could not run" >&2
else
"${TOPLEVEL}"/scripts/spell_check/check_spelling.sh "$MODIFIED"
fi
# Run doxygen layout test if requirements are met
if test "$HAS_AG" != "true"; then
echo "WARNING: the ag(1) executable was not found, doxygen layout checker could not run" >&2
elif test "$HAS_UNBUFFER" != "true"; then
echo "WARNING: the unbuffer(1) executable was not found, doxygen layout checker could not run" >&2
else
"${TOPLEVEL}"/tests/code_layout/test_doxygen_layout.sh $MODIFIED
fi
MODIFIED_SHELLFILES=$(echo "${MODIFIED}" | grep '\.sh$' || true)
if [ -n "$MODIFIED_SHELLFILES" ]; then
# Run shell checker if requirements are met
if command -v shellcheck > /dev/null; then
${TOPLEVEL}/tests/code_layout/test_shellcheck.sh "${MODIFIED_SHELLFILES}"
else
echo "WARNING: the shellcheck(1) executable was not found, shell checker could not run" >&2
fi
fi
FILES_CHANGED=0
# save original changes
REV=$(git log -n1 --pretty=%H)
#git diff >sha-"$REV".diff
ASTYLEDIFF=astyle.$REV.diff
true > "$ASTYLEDIFF"
# reformat
i=0
N=$(echo "$MODIFIED" | wc -w)
for f in $MODIFIED; do
(( i++ )) || true
case "$f" in
*.cpp|*.c|*.h|*.cxx|*.hxx|*.c++|*.h++|*.cc|*.hh|*.C|*.H|*.sip|*.mm)
;;
*)
continue
;;
esac
# only run astyle on sipified directories, others are handled by clang-format (see .pre-commit-config.yaml)
if [[ $f =~ ^src/(core) ]]; then
m=$f.$REV.prepare
cp "$f" "$m"
ASTYLEPROGRESS=" [$i/$N]" astyle.sh "$f"
if diff -u "$m" "$f" >>"$ASTYLEDIFF"; then
# no difference found
rm "$m"
fi
fi
done
if [ -s "$ASTYLEDIFF" ]; then
if tty -s; then
# review astyle changes
colordiff <"$ASTYLEDIFF" | less -r
rm "$ASTYLEDIFF"
else
echo "Files changed (see $ASTYLEDIFF)"
fi
FILES_CHANGED=1
else
rm "$ASTYLEDIFF"
fi
# verify SIP files
SIPIFYDIFF=sipify.$REV.diff
true > "$SIPIFYDIFF"
for root_dir in python python/PyQt6; do
if [[ $root_dir == "python/PyQt6" ]]; then
IS_QT6="-qt6"
fi
for f in $MODIFIED; do
# if cpp header
if [[ $f =~ ^src\/(core|gui|analysis|server|3d)\/.*\.h$ ]]; then
# look if corresponding SIP file
sip_file=$(${GP}sed -r 's@^src/(core|gui|analysis|server|3d)/@@; s@\.h$@.sip@' <<<"$f" )
pyfile=$(${GP}sed -E 's@([^\/]+\/)*([^\/]+)\.sip@\2.py@;' <<< "$sip_file")
module=$(${GP}sed -r 's@src/(core|gui|analysis|server|3d)/.*$@\1@' <<<"$f" )
if grep -Fq "$sip_file" "${TOPLEVEL}"/$root_dir/"${module}"/"${module}"_auto.sip; then
sip_file=$(${GP}sed -r 's@^src/(core|gui|analysis|server|3d)@\1/auto_generated@; s@\.h$@.sip.in@' <<<"$f" )
m=$root_dir/$sip_file.$REV.prepare
if [ ! -f $root_dir/"$sip_file" ]; then
touch $root_dir/"$sip_file"
fi
cp $root_dir/"$sip_file" "$m"
"${TOPLEVEL}"/scripts/sipify.py $IS_QT6 -sip_output $m -python_output $root_dir/"${module}"/auto_additions/"${pyfile}" "$f"
# only replace sip files if they have changed
if ! diff -u $root_dir/"$sip_file" "$m" >>"$SIPIFYDIFF"; then
echo "$root_dir/$sip_file is not up to date"
cp "$m" $root_dir/"$sip_file"
fi
rm "$m"
fi
fi
done
done
if [[ -s "$SIPIFYDIFF" ]]; then
if tty -s; then
# review astyle changes
colordiff <"$SIPIFYDIFF" | less -r
rm "$SIPIFYDIFF"
else
echo "Files changed (see $ASTYLEDIFF)"
fi
FILES_CHANGED=1
else
rm "$SIPIFYDIFF"
fi
exit $FILES_CHANGED
# vim: set ts=2 expandtab :
|